<html>
<head>
  <title>./1_interface_info/main.c</title>
</head>
<body bgcolor="#ffffff" text="#000000">
<pre>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-eth-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-interface-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-modem-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-network-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;libmcm/mcm-wifi-info.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;pthread.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;signal.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdio.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;stdlib.h&gt;</font></strong></font>
<font color="0000ff"><strong>#include <font color="#008000">&lt;string.h&gt;</font></strong></font>

<strong>void</strong> <font color="#2040a0">usage</font><font color="4444FF">(</font><strong>void</strong><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;USAGE: info [Interface Name]<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">show_ethernet_info</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong> <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>

    <font color="#2040a0">mcm_ethernet_info</font> <font color="#2040a0">ethernet_info</font><font color="4444FF">;</font>
    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">ethernet_info</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">mcm_ethernet_info</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_get_ethernet_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">ethernet_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get ethernet interface (%s) information failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Duplex:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">ethernet_info</font>.<font color="#2040a0">duplex</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Link Detecte:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="4444FF">(</font><font color="#2040a0">ethernet_info</font>.<font color="#2040a0">link_detected</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#2040a0">true</font><font color="4444FF">)</font> ? <font color="#008000">&quot;true&quot;</font> <font color="4444FF">:</font> <font color="#008000">&quot;false&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Link Speed:%d Mbps<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">ethernet_info</font>.<font color="#2040a0">link_speed</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">show_wifi_info</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong>           <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_wifi_info</font> <font color="#2040a0">wifi_info</font><font color="4444FF">;</font>

    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">wifi_info</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">mcm_wifi_info</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_get_wifi_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">wifi_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get wifi interface (%s) information failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="#2040a0">ret</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Operation Mode:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">operation_mode</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;BSSID:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">bssid</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;SSID:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">ssid</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;HWMode:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">hwmode</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Frequency:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">frequency</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Secure Mode:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">secure_mode</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Channel:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">wifi_info</font>.<font color="#2040a0">channel</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Broadcast:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="4444FF">(</font><font color="#2040a0">wifi_info</font>.<font color="#2040a0">broadcast</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#2040a0">true</font><font color="4444FF">)</font> ? <font color="#008000">&quot;true&quot;</font> <font color="4444FF">:</font> <font color="#008000">&quot;false&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">show_modem_info</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong>            <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_modem_info</font> <font color="#2040a0">modem_info</font><font color="4444FF">;</font>

    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">modem_info</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">mcm_modem_info</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_get_modem_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">modem_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get modem interface (%s) information failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="#2040a0">ret</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;CellID:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">cell_id</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Device IMEI:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">device_imei</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Network Rat:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">network_rat</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Operator:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">operator</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;SIM ICCID:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">sim_iccid</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;SIM IMSI:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">sim_imsi</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;TAC LAC:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">taclac</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;PIN Retries:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">pin_retries</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Signal Strength:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">signal_strength</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;SIM Slot :%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">sim_slot</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Modem State :%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">modem_state</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Modem Name :%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">modem_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Modem Version :%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">modem_info</font>.<font color="#2040a0">modem_version</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>return</strong> <font color="#FF0000">0</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">network_info</font><font color="4444FF">(</font><strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>int</strong>                <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_network_info</font>   <font color="#2040a0">network_info</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_network_status</font> <font color="#2040a0">network_stauts</font><font color="4444FF">;</font>
    <font color="#2040a0">mcm_profiles</font>      <font color="4444FF">*</font><font color="#2040a0">profiles</font><font color="4444FF">;</font>
    <strong>int</strong>                <font color="#2040a0">num</font><font color="4444FF">;</font>

    <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font>
        <font color="#2040a0">usage</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">network_info</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">mcm_network_info</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">memset</font><font color="4444FF">(</font><font color="4444FF">&amp;</font><font color="#2040a0">network_stauts</font>, <font color="#FF0000">0</font>, <strong>sizeof</strong><font color="4444FF">(</font><font color="#2040a0">network_stauts</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_get_network_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">network_info</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) information failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Name:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Device Type:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Device Name:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">device_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Enabled:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">enabled</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#2040a0">true</font><font color="4444FF">)</font> ? <font color="#008000">&quot;true&quot;</font> <font color="4444FF">:</font> <font color="#008000">&quot;false&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;WAN Priority:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">wan_priority</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Network:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">network_type</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;IPV4 Address Method:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">ipv4_method</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;MAC Address:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_info</font>.<font color="#2040a0">mac_address</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;-----------------------------------------------------<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_get_network_status</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">network_stauts</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) status failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>

    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Default Route:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="4444FF">(</font><font color="#2040a0">network_stauts</font>.<font color="#2040a0">default_route</font> <font color="4444FF">=</font><font color="4444FF">=</font> <font color="#2040a0">true</font><font color="4444FF">)</font> ? <font color="#008000">&quot;true&quot;</font> <font color="4444FF">:</font> <font color="#008000">&quot;false&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;IPV4 Address:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_stauts</font>.<font color="#2040a0">ipv4_address</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;IPV4 Netmask:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_stauts</font>.<font color="#2040a0">ipv4_netmask</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;IPV4 Gateway:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_stauts</font>.<font color="#2040a0">ipv4_gateway</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;IPV4 PrimaryDNS:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_stauts</font>.<font color="#2040a0">ipv4_dns</font><font color="4444FF">[</font><font color="#FF0000">0</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;IPV4 SecondaryDNS:%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_stauts</font>.<font color="#2040a0">ipv4_dns</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Connection State:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">network_stauts</font>.<font color="#2040a0">connection_status</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;-----------------------------------------------------<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">mcm_get_network_profiles</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font>, <font color="4444FF">&amp;</font><font color="#2040a0">num</font>, <font color="4444FF">&amp;</font><font color="#2040a0">profiles</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">ret</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;ERROR: Get interface (%s) profiles failed:%d<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">interface_name</font>, <font color="#2040a0">ret</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;Profiles:<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>for</strong> <font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">i</font> <font color="4444FF">=</font> <font color="#FF0000">0</font><font color="4444FF">;</font> <font color="#2040a0">i</font> <font color="4444FF">&lt;</font> <font color="#2040a0">num</font><font color="4444FF">;</font> <font color="#2040a0">i</font><font color="4444FF">+</font><font color="4444FF">+</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;<font color="#77dd77">\t</font>%s<font color="#77dd77">\n</font>&quot;</font>, <font color="#2040a0">profiles</font><font color="4444FF">[</font><font color="#2040a0">i</font><font color="4444FF">]</font>.<font color="#2040a0">profile_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>
    <font color="#2040a0">printf</font><font color="4444FF">(</font><font color="#008000">&quot;-----------------------------------------------------<font color="#77dd77">\n</font>&quot;</font><font color="4444FF">)</font><font color="4444FF">;</font>

    <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font>, <font color="#008000">&quot;Ethernet&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;Ethernet&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">show_ethernet_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font>, <font color="#008000">&quot;WiFi&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;WiFi&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">show_wifi_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>else</strong> <strong>if</strong> <font color="4444FF">(</font><font color="4444FF">!</font><font color="#2040a0">strncmp</font><font color="4444FF">(</font><font color="#2040a0">network_info</font>.<font color="#2040a0">device_type</font>, <font color="#008000">&quot;Modem&quot;</font>, <font color="#2040a0">strlen</font><font color="4444FF">(</font><font color="#008000">&quot;Modem&quot;</font><font color="4444FF">)</font><font color="4444FF">)</font><font color="4444FF">)</font>
        <font color="#2040a0">ret</font> <font color="4444FF">=</font> <font color="#2040a0">show_modem_info</font><font color="4444FF">(</font><font color="#2040a0">interface_name</font><font color="4444FF">)</font><font color="4444FF">;</font>
    <strong>return</strong> <font color="#2040a0">ret</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

<strong>int</strong> <font color="#2040a0">main</font><font color="4444FF">(</font><strong>int</strong> <font color="#2040a0">argc</font>, <strong>char</strong> <font color="4444FF">*</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="4444FF">]</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
    <strong>if</strong> <font color="4444FF">(</font><font color="#2040a0">argc</font> <font color="4444FF">!</font><font color="4444FF">=</font> <font color="#FF0000">2</font><font color="4444FF">)</font> <font color="4444FF"><strong>{</strong></font>
        <font color="#2040a0">usage</font><font color="4444FF">(</font><font color="4444FF">)</font><font color="4444FF">;</font>
        <strong>return</strong> <font color="4444FF">-</font><font color="#FF0000">1</font><font color="4444FF">;</font>
    <font color="4444FF"><strong>}</strong></font>
    <strong>return</strong> <font color="#2040a0">network_info</font><font color="4444FF">(</font><font color="#2040a0">argv</font><font color="4444FF">[</font><font color="#FF0000">1</font><font color="4444FF">]</font><font color="4444FF">)</font><font color="4444FF">;</font>
<font color="4444FF"><strong>}</strong></font>

</pre>
<hr>
syntax highlighted by <a href="http://www.palfrader.org/code2html">Code2HTML</a>, v. 0.9.1
</body>
</html>
